--[[
	This AddOn is dedicated to one of my friends, and most of the credit goes to Mischback @ WoWInterface, for helping me with the code!
]]

local ADDON_NAME, ns = ... -- Don't touch this.

	-- Little config:
local fontface = "Fonts\\FRIZQT__.TTF" -- The path to the font "Interface\\AddOns\\path to your font.TTF" or Fonts\\FRIZQT__.TTF for default game font
local showalways = false	--[[ Set to true to make the frames movable upon entering the world, set to false to make them unmovable upon entering the world. false is default.
								 The show always thing is mostly for me (Author), as I'm too lazy to type out /ufunlock upon every log in... ]]
local useblizz = false --[[ Set to false to use the default values from this AddOn, instead of Blizzards default position values - Used for when you press the default button.
							Not yet in use!! Will be in next update]]

-- Defaults
local SavedVar = {
	["player"] = {
		["xpos"] = -150,
		["ypos"] = 0,
		["anchor"] = "CENTER",
		["relativePoint"] = "CENTER",
	},
	["target"] = {
		["xpos"] = 150,
		["ypos"] = 0,
		["anchor"] = "CENTER",
		["relativePoint"] = "CENTER",
	},
	["p1"] = {
		["xpos"] = 10,
		["ypos"] = -160,
		["anchor"] = "TOPLEFT",
		["relativePoint"] = "TOPLEFT",
	},
	["p2"] = {
		["xpos"] = 10,
		["ypos"] = -223,
		["anchor"] = "TOPLEFT",
		["relativePoint"] = "TOPLEFT",
	},
	["p3"] = {
		["xpos"] = 10,
		["ypos"] = -286,
		["anchor"] = "TOPLEFT",
		["relativePoint"] = "TOPLEFT",
	},
	["p4"] = {
		["xpos"] = 10,
		["ypos"] = -349,
		["anchor"] = "TOPLEFT",
		["relativePoint"] = "TOPLEFT",
	},
}

-- Functions
	-- Saving the variables to the DB
local function SaveToDB(frame, key) 
	local anchor, relativeTo, relativePoint, xOfs, yOfs = frame:GetPoint()
	Position[key].anchor = anchor
	Position[key].relativePoint = relativePoint
	Position[key].xpos = xOfs
	Position[key].ypos = yOfs
end
	-- Guidanceframes setup
local function MakeItWork(frame)
	frame:SetFont(fontface, 10, "MONOCROME")
	frame:SetInsertMode("TOP")
	frame:SetFading(false)
	frame:SetJustifyH("LEFT")
	frame:SetJustifyV("TOP")
	frame:EnableMouse(true)
end
	
--[[	-- This is for the next update
	-- Reseting to default
local function pdefault()
	if (useblizz == true) then
	PlayerFrame:Setpoint()
	else
	PlayerFrame:SetPoint(SavedVar.player.anchor, UIParent, SavedVar.player.relativepoint, SavedVar.player.xpos, SavedVar.player.ypos)
	end
end
local function tdefault()
	if (useblizz == true) then
	TargetFrame:SetPoint()
	else
	TargetFrame:SetPoint(SavedVar.target.anchor, UIParent, SavedVar.target.relativepoint, SavedVar.target.xpos, SavedVar.target.ypos)
	end
end
local function p1default()
	PartyFrame1:SetPoint(SavedVar.p1.anchor, UIParent, SavedVar.p1.relativepoint, SavedVar.p1.xpos, SavedVar.p1.ypos)
end
local function p2default()
	PartyFrame2:SetPoint(SavedVar.p2.anchor, UIParent, SavedVar.p2.relativepoint, SavedVar.p2.xpos, SavedVar.p2.ypos)
end
local function p3default()
	PartyFrame3:SetPoint(SavedVar.p3.anchor, UIParent, SavedVar.p3.relativepoint, SavedVar.p3.xpos, SavedVar.p3.ypos)
end
local function p4default()
	PartyFrame4:SetPoint(SavedVar.p4.anchor, UIParent, SavedVar.p4.relativepoint, SavedVar.p4.xpos, SavedVar.p4.ypos)
end
]]

	-- Guidance frames
		-- infoframe
local uinfo = CreateFrame("MessageFrame", "uinfo")
uinfo:SetPoint("CENTER", UIParent, "CENTER", 0, 300)
MakeItWork(uinfo)
uinfo:SetSize(250, 100)
uinfo:AddMessage("lock the individual ones.", 1, 0.75, 0, 1)
uinfo:AddMessage("While the buttons on the smaller frames", 1, 0.75, 0, 1)
uinfo:AddMessage("or resets them all.", 1, 0.75, 0, 1)
uinfo:AddMessage("The buttons on this frame locks all frames,", 1, 0.75, 0, 1)
uinfo:AddMessage("To lock them, press one of the buttons.", 1, 0.75, 0, 1)
uinfo:AddMessage("To move the frames, simply drag the squares.", 1, 0.75, 0, 1)
uinfo:AddMessage("The frames are now movable.", 1, 0.75, 0, 1)
uinfo:AddMessage("Zynix Unitframes:", 1, 0.75, 0, 1)

local utex = uinfo:CreateTexture("OVERLAY")
utex:SetAllPoints(uinfo)
utex:SetTexture(0, 0, 0, 0.5)

local ubutton = CreateFrame("Button", "ubutton", uinfo, "UIPanelButtonTemplate")
ubutton:SetWidth(65)
ubutton:SetHeight(20)
ubutton:SetPoint("BOTTOMRIGHT", uinfo, "BOTTOMRIGHT", -1, 1)

local ufont = ubutton:CreateFontString(nil, "OVERLAY")
ufont:SetFont(fontface, 10)
ufont:SetPoint("CENTER", 0, 0)
ufont:SetTextColor(1, 0.75, 0, 1)
ufont:SetText("Lock")

--[[		-- This is also for the next update 
local udbutton = CreateFrame("Button", "udbutton", uinfo, "UIPanelButtonTemplate")
udbutton:SetWidth(65)
udbutton:SetHeight(20)
udbutton:SetPoint("BOTTOMLEFT", uinfo, "BOTTOMLEFT", 1, 1)

local udfont = udbutton:CreateFontString(nil, "OVERLAY")
udfont:SetFont(fontface, 10)
udfont:SetPoint("CENTER", 0, 0)
udfont:SetTextColor(1, 0.75, 0, 1)
udfont:SetText("Reset")
]]

		-- player
local pback = CreateFrame("MessageFrame")
pback:SetPoint("CENTER", PlayerFrame, "CENTER", 0, 0)
pback:SetSize(PlayerFrame:GetSize())
MakeItWork(pback)
pback:AddMessage("Player Frame", 1, 0.75, 0, 1)

local ptex = pback:CreateTexture("OVERLAY")
ptex:SetAllPoints(pback)
ptex:SetTexture(0, 0, 0, 0.5)

local pbutton = CreateFrame("Button", "pbutton", pback, "UIPanelButtonTemplate")
pbutton:SetWidth(65)
pbutton:SetHeight(20)
pbutton:SetPoint("BOTTOMRIGHT", pback, "BOTTOMRIGHT", -1, 1)

local pfont = pbutton:CreateFontString(nil, "OVERLAY")
pfont:SetFont(fontface, 10)
pfont:SetPoint("CENTER", 0, 0)
pfont:SetTextColor(1, 0.75, 0, 1)
pfont:SetText("Lock")

		-- Target
local tback = CreateFrame("MessageFrame")
tback:SetPoint("CENTER", TargetFrame, "CENTER", 0, 0)
tback:SetSize(TargetFrame:GetSize())
MakeItWork(tback)
tback:AddMessage("Target Frame", 1, 0.75, 0, 1)

local ttex = tback:CreateTexture("OVERLAY")
ttex:SetAllPoints(tback)
ttex:SetTexture(0, 0, 0, 0.5)

local tbutton = CreateFrame("Button", "tbutton", tback, "UIPanelButtonTemplate")
tbutton:SetWidth(65)
tbutton:SetHeight(20)
tbutton:SetPoint("BOTTOMRIGHT", tback, "BOTTOMRIGHT", -1, 1)

local tfont = tbutton:CreateFontString(nil, "OVERLAY")
tfont:SetFont(fontface, 10)
tfont:SetPoint("CENTER", 0, 0)
tfont:SetTextColor(1, 0.75, 0, 1)
tfont:SetText("Lock")

		-- Partyframes:
			-- Party1
local p1back = CreateFrame("MessageFrame")
p1back:SetPoint("TOPLEFT", PartyMemberFrame1, "TOPLEFT", 0, 0)
p1back:SetSize(PartyMemberFrame1:GetWidth() + 15, PartyMemberFrame1:GetHeight() + 10)
MakeItWork(p1back)
p1back:AddMessage("Party Frame 1", 1, 0.75, 0, 1)

local p1tex = p1back:CreateTexture("OVERLAY")
p1tex:SetAllPoints(p1back)
p1tex:SetTexture(0, 0, 0, 0.5)

local p1button = CreateFrame("Button", "p1button", p1back, "UIPanelButtonTemplate")
p1button:SetWidth(65)
p1button:SetHeight(20)
p1button:SetPoint("BOTTOMRIGHT", p1back, "BOTTOMRIGHT", -1, 1)

local p1font = p1button:CreateFontString(nil, "OVERLAY")
p1font:SetFont(fontface, 10)
p1font:SetPoint("CENTER", 0, 0)
p1font:SetTextColor(1, 0.75, 0, 1)
p1font:SetText("Lock")

			--Party2
local p2back = CreateFrame("MessageFrame")
p2back:SetPoint("TOPLEFT", PartyMemberFrame2, "TOPLEFT", 0, 0)
p2back:SetSize(PartyMemberFrame2:GetWidth() + 15, PartyMemberFrame2:GetHeight() + 10)
MakeItWork(p2back)
p2back:AddMessage("Party Frame 2", 1, 0.75, 0, 1)

local p2tex = p2back:CreateTexture("OVERLAY")
p2tex:SetAllPoints(p2back)
p2tex:SetTexture(0, 0, 0, 0.5)

local p2button = CreateFrame("Button", "p2button", p2back, "UIPanelButtonTemplate")
p2button:SetWidth(65)
p2button:SetHeight(20)
p2button:SetPoint("BOTTOMRIGHT", p2back, "BOTTOMRIGHT", -1, 1)

local p2font = p2button:CreateFontString(nil, "OVERLAY")
p2font:SetFont(fontface, 10)
p2font:SetPoint("CENTER", 0, 0)
p2font:SetTextColor(1, 0.75, 0, 1)
p2font:SetText("Lock")

			--Party3
local p3back = CreateFrame("MessageFrame")
p3back:SetPoint("TOPLEFT", PartyMemberFrame3, "TOPLEFT", 0, 0)
p3back:SetSize(PartyMemberFrame3:GetWidth() + 15, PartyMemberFrame3:GetHeight() + 10)
MakeItWork(p3back)
p3back:AddMessage("Party Frame 3", 1, 0.75, 0, 1)

local p3tex = p3back:CreateTexture("OVERLAY")
p3tex:SetAllPoints(p3back)
p3tex:SetTexture(0, 0, 0, 0.5)

local p3button = CreateFrame("Button", "p3button", p3back, "UIPanelButtonTemplate")
p3button:SetWidth(65)
p3button:SetHeight(20)
p3button:SetPoint("BOTTOMRIGHT", p3back, "BOTTOMRIGHT", -1, 1)

local p3font = p3button:CreateFontString(nil, "OVERLAY")
p3font:SetFont(fontface, 10)
p3font:SetPoint("CENTER", 0, 0)
p3font:SetTextColor(1, 0.75, 0, 1)
p3font:SetText("Lock")

			--Party4
local p4back = CreateFrame("MessageFrame")
p4back:SetPoint("TOPLEFT", PartyMemberFrame4, "TOPLEFT", 0, 0)
p4back:SetSize(PartyMemberFrame4:GetWidth() + 15, PartyMemberFrame4:GetHeight() + 10)
MakeItWork(p4back)
p4back:AddMessage("Party Frame 4", 1, 0.75, 0, 1)

local p4tex = p4back:CreateTexture("OVERLAY")
p4tex:SetAllPoints(p4back)
p4tex:SetTexture(0, 0, 0, 0.5)

local p4button = CreateFrame("Button", "p4button", p4back, "UIPanelButtonTemplate")
p4button:SetWidth(65)
p4button:SetHeight(20)
p4button:SetPoint("BOTTOMRIGHT", p4back, "BOTTOMRIGHT", -1, 1)

local p4font = p4button:CreateFontString(nil, "OVERLAY")
p4font:SetFont(fontface, 10)
p4font:SetPoint("CENTER", 0, 0)
p4font:SetTextColor(1, 0.75, 0, 1)
p4font:SetText("Lock")
	-- Guidance Frames end

	-- Creating a frame for the initialization of the AddOn, and the moving of the frames
local init = CreateFrame("Frame")
init:RegisterEvent("ADDON_LOADED")
init:SetScript("OnEvent", function(self, event, addon)
	if ( addon ~= ADDON_NAME ) then return end		-- jump out, if it's not our addon
	local k, v
	
	-- If everything is as it should be, then do this
	PlayerFrame:SetMovable(false)
	TargetFrame:SetMovable(false)
	PartyMemberFrame1:SetMovable(false)
	PartyMemberFrame2:SetMovable(false)
	PartyMemberFrame3:SetMovable(false)
	PartyMemberFrame4:SetMovable(false)
	if showalways then
		pback:Show()
		tback:Show()
		uinfo:Show()
		p1back:Show()
		p2back:Show()
		p3back:Show()
		p4back:Show()
		PlayerFrame:SetMovable(true)
		TargetFrame:SetMovable(true)
		PartyMemberFrame1:SetMovable(true)
		PartyMemberFrame2:SetMovable(true)
		PartyMemberFrame3:SetMovable(true)
		PartyMemberFrame4:SetMovable(true)
	else
		pback:Hide()
		p1back:Hide()
		p2back:Hide()
		p3back:Hide()
		p4back:Hide()
		tback:Hide()
		uinfo:Hide()
	end
	
	-- First startup
	if not Position then
		Position = {}
		PlayerFrame:SetMovable(true)
		TargetFrame:SetMovable(true)
		PartyMemberFrame1:SetMovable(true)
		PartyMemberFrame2:SetMovable(true)
		PartyMemberFrame3:SetMovable(true)
		PartyMemberFrame4:SetMovable(true)
		PartyMemberFrame1:SetUserPlaced(false)
		PartyMemberFrame2:SetUserPlaced(false)
		PartyMemberFrame3:SetUserPlaced(false)
		PartyMemberFrame4:SetUserPlaced(false)
		pback:Show()
		tback:Show()
		p1back:Show()
		p2back:Show()
		p3back:Show()
		p4back:Show()
		uinfo:Show()
	end
	
	for k, v in pairs(SavedVar) do
		if type(v) ~= type(Position[k]) then
			Position[k] = v
		end
	end
	
	-- Finally through
	PlayerFrame:ClearAllPoints()
	PlayerFrame:SetPoint(Position.player.anchor, UIParent, Position.player.relativePoint, Position.player.xpos, Position.player.ypos)
	SaveToDB(PlayerFrame, "player") 
	TargetFrame:ClearAllPoints()
	TargetFrame:SetPoint(Position.target.anchor, UIParent, Position.target.relativePoint, Position.target.xpos, Position.target.ypos)
	SaveToDB(TargetFrame, "target")
	PartyMemberFrame1:ClearAllPoints()
	PartyMemberFrame1:SetPoint(Position.p1.anchor, UIParent, Position.p1.relativePoint, Position.p1.xpos, Position.p1.ypos)
	SaveToDB(PartyMemberFrame1, "p1")
	PartyMemberFrame2:ClearAllPoints()
	PartyMemberFrame2:SetPoint(Position.p2.anchor, UIParent, Position.p2.relativePoint, Position.p2.xpos, Position.p2.ypos)
	SaveToDB(PartyMemberFrame2, "p2")
	PartyMemberFrame3:ClearAllPoints()
	PartyMemberFrame3:SetPoint(Position.p3.anchor, UIParent, Position.p3.relativePoint, Position.p3.xpos, Position.p3.ypos)
	SaveToDB(PartyMemberFrame3, "p3")
	PartyMemberFrame4:ClearAllPoints()
	PartyMemberFrame4:SetPoint(Position.p4.anchor, UIParent, Position.p4.relativePoint, Position.p4.xpos, Position.p4.ypos)
	SaveToDB(PartyMemberFrame4, "p4")
	PlayerFrame.SetPoint = function() end
end)
	-- Slashcommands:
		-- unlocking the frame
SLASH_UNLOCK1 = "/ufunlock"
SlashCmdList["UNLOCK"] = function()
	PlayerFrame:SetMovable(true)
	TargetFrame:SetMovable(true)
	PartyMemberFrame1:SetMovable(true)
	PartyMemberFrame2:SetMovable(true)
	PartyMemberFrame3:SetMovable(true)
	PartyMemberFrame4:SetMovable(true)
	pback:Show()
	tback:Show()
	p1back:Show()
	p2back:Show()
	p3back:Show()
	p4back:Show()
	uinfo:Show()
end

		-- Author help
--[[ Developer tool
SLASH_FRAMENAME1 = "/frame"
SlashCmdList["FRAMENAME"] = function() 
	local anchor, relativeTo, relativePoint, xOfs, yOfs = GetMouseFocus():GetPoint()
	local name = GetMouseFocus():GetName()
	local width, height = GetMouseFocus():GetSize()
	DEFAULT_CHAT_FRAME:AddMessage("|cffffd700Zynix UnitFrames Info:|r")
	DEFAULT_CHAT_FRAME:AddMessage("|cffffd700Position: |r"..anchor.." / "..relativeTo:GetName().." / "..relativePoint.." / "..xOfs.." / "..yOfs.."")
	DEFAULT_CHAT_FRAME:AddMessage("|cffffd700Width: |r"..width.."")
	DEFAULT_CHAT_FRAME:AddMessage("|cffffd700Height: |r"..height.."")
	if (GetMouseFocus():GetName() == nil) then return 
	else
	DEFAULT_CHAT_FRAME:AddMessage("|cffffd700Name: |r"..name.."")
	end
end
]]	-- Slashcommands end
	
	-- Scripts:
		-- locking the frame(s)
			-- Player
pbutton:SetScript("OnClick", function()	
	pback:Hide()
	PlayerFrame:SetMovable(false)
	if (tback:IsShown()==nil) and (p1back:IsShown()==nil) and (p2back:IsShown()==nil) and (p3back:IsShown()==nil) and (p4back:IsShown()==nil) then
	uinfo:Hide()
	end
end)

			-- Target
tbutton:SetScript("OnClick", function()
	tback:Hide()
	TargetFrame:SetMovable(false)
	if (pback:IsShown()==nil) and (p1back:IsShown()==nil) and (p2back:IsShown()==nil) and (p3back:IsShown()==nil) and (p4back:IsShown()==nil) then
	uinfo:Hide()
	end
end)

			-- Party1
p1button:SetScript("OnClick", function()	
	p1back:Hide()
	PartyMemberFrame1:SetMovable(false)
	if (pback:IsShown()==nil) and (tback:IsShown()==nil) and (p2back:IsShown()==nil) and (p3back:IsShown()==nil) and (p4back:IsShown()==nil) then
	uinfo:Hide()
	end
end)

			-- Party2
p2button:SetScript("OnClick", function()	
	p2back:Hide()
	PartyMemberFrame2:SetMovable(false)
	if (pback:IsShown()==nil) and (p1back:IsShown()==nil) and (tback:IsShown()==nil) and (p3back:IsShown()==nil) and (p4back:IsShown()==nil) then
	uinfo:Hide()
	end
end)

			-- Party3
p3button:SetScript("OnClick", function()	
	p3back:Hide()
	PartyMemberFrame3:SetMovable(false)
	if (pback:IsShown()==nil) and (p1back:IsShown()==nil) and (p2back:IsShown()==nil) and (tback:IsShown()==nil) and (p4back:IsShown()==nil) then
	uinfo:Hide()
	end
end)

			-- Party4
p4button:SetScript("OnClick", function()	
	p4back:Hide()
	PartyMemberFrame4:SetMovable(false)
	if (pback:IsShown()==nil) and (p1back:IsShown()==nil) and (p2back:IsShown()==nil) and (p3back:IsShown()==nil) and (tback:IsShown()==nil) then
	uinfo:Hide()
	end
end)
			-- Infoframe
ubutton:SetScript("OnClick", function()
	PlayerFrame:SetMovable(false)
	TargetFrame:SetMovable(false)
	PartyMemberFrame1:SetMovable(true)
	PartyMemberFrame2:SetMovable(true)
	PartyMemberFrame3:SetMovable(true)
	PartyMemberFrame4:SetMovable(true)
	pback:Hide()
	tback:Hide()
	uinfo:Hide()
	p1back:Hide()
	p2back:Hide()
	p3back:Hide()
	p4back:Hide()
end)
		-- Locking scripts end

--[[ 		-- this is for the next update
		-- Default scripts
udbutton:SetScript("OnClick", pdefault) 
]]

		-- The actual moving, stopping and saving
			-- Player
pback:SetScript("OnMouseDown", function()
	if PlayerFrame:IsMovable() == 1 then
		PlayerFrame:StartMoving()
	else PlayerFrame:StopMovingOrSizing()
	end
end)

pback:SetScript("OnMouseUp", function()
	PlayerFrame:StopMovingOrSizing()
	SaveToDB(PlayerFrame, "player")
end)

			-- Target
tback:SetScript("OnMouseDown", function()
	if TargetFrame:IsMovable() == 1 then
		TargetFrame:StartMoving()
	else TargetFrame:StopMovingOrSizing()
	end
end)

tback:SetScript("OnMouseUp", function()
	TargetFrame:StopMovingOrSizing()
	SaveToDB(TargetFrame, "target")
end)

			-- Party1
p1back:SetScript("OnMouseDown", function()
	if PartyMemberFrame1:IsMovable() == 1 then
		PartyMemberFrame1:StartMoving()
	else PartyMemberFrame1:StopMovingOrSizing()
	end
end)

p1back:SetScript("OnMouseUp", function()
	PartyMemberFrame1:StopMovingOrSizing()
	SaveToDB(PartyMemberFrame1, "p1")
end)

			-- Party2
p2back:SetScript("OnMouseDown", function()
	if PartyMemberFrame2:IsMovable() == 1 then
		PartyMemberFrame2:StartMoving()
	else PartyMemberFrame2:StopMovingOrSizing()
	end
end)

p2back:SetScript("OnMouseUp", function()
	PartyMemberFrame2:StopMovingOrSizing()
	SaveToDB(PartyMemberFrame2, "p2")
end)
			
			-- Party3
p3back:SetScript("OnMouseDown", function()
	if PartyMemberFrame3:IsMovable() == 1 then
		PartyMemberFrame3:StartMoving()
	else PartyMemberFrame3:StopMovingOrSizing()
	end
end)

p3back:SetScript("OnMouseUp", function()
	PartyMemberFrame3:StopMovingOrSizing()
	SaveToDB(PartyMemberFrame3, "p3")
end)

			-- Party4
p4back:SetScript("OnMouseDown", function()
	if PartyMemberFrame4:IsMovable() == 1 then
		PartyMemberFrame4:StartMoving()
	else PartyMemberFrame4:StopMovingOrSizing()
	end
end)

p4back:SetScript("OnMouseUp", function()
	PartyMemberFrame4:StopMovingOrSizing()
	SaveToDB(PartyMemberFrame4, "p4")
end)